clc; clear all; close all

Transform_Data

nobs = size(data(:,1),1);
%ret_{t+1,t+6} --> the last is ret_{2003,2008} --> the regressor will go
%from 1904 to 2002 (this is the effective sample)

%This is the sample used to compute regressand and regressor
smplsdate = ical(1904,1,cstr);
smpledate = ical(2008,1,cstr);

%%

% smplsdate = ical(1955,1,cstr);
% smpledate = ical(2008,1,cstr);

% smplsdate = ical(1926,1,cstr);
% smplsdate = ical(1955,1,cstr);
% smpledate = ical(2003,1,cstr);

%Horizons --> numbers of eqs.
H=[1:6];
% H=[1:5];
% H=[6:10];
maxH=H(end);
% CointldptfpmyVECM = ldp +  0.2618 * at +  1.4438 * my;     %VECM on the entire sample

x1 = trimr(ldp(smplsdate:smpledate,1),0,maxH);

% x1 = trimr(cayp(smplsdate:smpledate,1),0,maxH);
% x1 = trimr(rrel(smplsdate:smpledate,1),0,maxH);
% x1 = trimr(default(smplsdate:smpledate,1),0,maxH);
% x1 = trimr(term(smplsdate:smpledate,1),0,maxH);

% x1 = trimr(ldp5494(smplsdate:smpledate,1),0,maxH);

    c3 = [-0.42 -0.44 -0.38 -0.36 -0.33 -0.29]./[0.19 0.20 0.16 0.16 0.14 0.13]; % for real returns
%     c3 = [-0.12 -0.03 0.03 0.06 0.06 0.06]./[0.10 0.05 0.02 0.01 -0.005 -0.005]; % for dividends growth
%     c3 = [-0.55 -0.47 -0.35 -0.31 -0.27 -0.23]./[0.28 0.24 0.18 0.16 0.14 0.12]; % for returns - dividends growth

% x1 = trimr(ldpc(smplsdate:smpledate,1),0,maxH);
% add the constant
smpl_range = size(x1,1);
x= [ones(smpl_range,1) x1];

% % y=NaN(smpledate - smplsdate - maxH + 1, maxH);

% set up a structure for y in each eqn
% set up a structure for X in each eqn

% make sure 'data' is an empty structure
y = struct;
X = struct; X_r = struct;
for ii=1:size(H,2)
%    % JFQA Revise
%     temp = [lp ld];
    temp = [ldp];
    x1 = trimr(temp(smplsdate:smpledate,:),0,maxH) - c3(ii)*  my(smplsdate+H(ii):smpledate-(maxH-H(ii)));
%        x1 = [trimr(temp(smplsdate:smpledate,:),0,maxH) my(smplsdate+H(ii):smpledate-(maxH-H(ii)))];
     
    smpl_range = size(x1,1); x= [ones(smpl_range,1) x1];
%     y(ii).eq = (trimr(compounded_return(lret_ex(smplsdate:smpledate,1),H(ii)),0,maxH-H(ii)))/H(ii);
    y(ii).eq = (trimr(compounded_return(ret_r(smplsdate:smpledate,1),H(ii)),0,maxH-H(ii)))/H(ii);
%     y(ii).eq = (trimr(compounded_return(div_gr_r(smplsdate:smpledate,1),H(ii)),0,maxH-H(ii)))/H(ii);
%     y(ii).eq = (trimr(compounded_return(ret_r(smplsdate:smpledate,1)-div_gr_r(smplsdate:smpledate,1),H(ii)),0,maxH-H(ii)))/H(ii);
    X(ii).eq = x;
    X_r(ii).eq= x(:,1);
end

% do sur regression with iteration
neqs = size(H,2); iflag = 1; % rely on default itmax, crit values
result   = sur(neqs,y,X  ,iflag);
result_r = sur(neqs,y,X_r,iflag);

OMEGA  = result.sigma; 
OMEGA_r= result_r.sigma; 

% compute sur residuals
myresidual  =NaN(smpledate - smplsdate - maxH + 1, size(H,2));
myresidual_r=NaN(smpledate - smplsdate - maxH + 1, size(H,2));
for ii=1:size(H,2)
    myresidual(:,ii) = result(ii).resid;
    myresidual_r(:,ii) = result_r(ii).resid;
end

% implementing (7.53) "Econometric analysis of cross section and panel data - Jeffrey M. Wooldridge"
N=result(1).nobs;
G=result(1).neqs;
K=result(1).nvar*G;

Q=G;

SSRu=0; SSRr=0;
invOMEGA=inv(OMEGA);
% invOMEGA_r=inv(OMEGA_r);
for ii=1:N
    SSRu=SSRu + myresidual(ii,:)   * invOMEGA * myresidual(ii,:)';
    SSRr=SSRr + myresidual_r(ii,:) * invOMEGA * myresidual_r(ii,:)';
end

% FTEST=((SSRr-SSRu)/Q)
FTEST=((SSRr-SSRu)/SSRu) * ((N*G-K)/Q);
fprb = fdis_prb(FTEST,Q,N*G-K);

% cay     --> FTEST =7.7038 fprb = 2.3827e-011
% term    --> FTEST =1.6977 fprb = 0.0789
% default --> FTEST =1.9200 fprb = 0.0409
% rrel    --> FTEST =1.0157 fprb = 0.4291
% dpTMY   --> FTEST = 4.341 fprb = 8.4637e-006