% Define path and load data

%Cay is taken from Quarterly Data
[data, names] = xlsread( [ 'E:\S&P500\Univariate_Analysis\', 'MainDataBaseDecember.xls'] );

nobs = size(data(:,1),1);
%calendar structure
cstr=cal(1900,1,1,nobs);
endperiod = ical(2008,1,cstr);

start = ical(1909,1,cstr);
break1 = ical(1954,1,cstr);
break2= ical(1994,1,cstr);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%Data Iput%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cpi = data(:,20);

%plot(ldp_dm); hold on; plot(ldp5494)

ld  = log(data(:,3));

lp  = log(data(:,2));% ex dividend vwindx
ldp = ld-lp;

% BOUDOUKH
ldpa = data(:,30);
ldpb = data(:,31);
ldpc = data(:,32);
ldpd = data(:,33);

le = log(data(:,4));

lpe = lp - le;
lde = ld - le;
ldp5494(start:break1,1)=ldp(start:break1) - mean(ldp(start:break1));
ldp5494(break1+1:break2,1)=ldp(break1+1:break2) - mean(ldp(break1+1:break2));
ldp5494(break2+1:endperiod,1)=ldp(break2+1:endperiod) - mean(ldp(break2+1:endperiod));

infl_l=log(cpi./lag(cpi));

my = data(:,6); %[40 - 64]/ [20 - 39]

% Original TFP from BlS scaled to match with Solow series
at = data(:,8); % we start with 1 as in Solow(1957)

ret=((data(:,2)+data(:,3))./lag(data(:,2)))-1;
lret = log(1+ret); %cum dividend return
ret_r = lret-infl_l;

div_gr = (data(:,3)./lag((data(:,3))))-1;
ln_divg_r = log(1+div_gr);
div_gr_r = ln_divg_r-infl_l;
% lrf = lag(log(1+0.01*(data(:,7))));
lrf = log(1+0.01*(data(:,21)));

lret_ex = lret - lrf; % excess return continuously compounded return (over 3 Month)
%plot(lret); hold on; plot(lret_ex,'r')

% Calculated from monthly data(CRSP 3mTB(90days)) following Lamont(1998)
rrel = data(:,27);

yield_a = (log(1+(lag(data(:,27))/100)));
% term= yield_a-lrf ;
term= data(:,25) ;

default= data(:,26);

%From updated quarterly series - end of the period value is taken as
%representative of the entire year
cayp = data(:,9);  % demeaned taken from Prof. Ludvigson website
cdyp = data(:,12); % demeaned taken from Prof. Ludvigson website

% c=data(:,18); 
% a=data(:,19);
% income=data(:,20);
% cay_estimated_all_sample = c - 0.2251 * a - 0.6589 * income;

%RREL= data(:,17); % Calculated from monthly data(CRSP 3mTB(90days)) following Lamont(1998)