clear all; close all; clc;

rep = 5000;

%% values for Table 4
% Tvec = 78; %for Boudoukh et al. regressor --> 2003-1926+1
Tvec=99;
% values for dp,dpLvN,dpBoudoukh and dp+MY
% cvec    =[-1.12 -2.0  -2.85 -2.5];
% deltavec=[-0.85 -0.74 -0.37 -0.78];
cvec    =[-2.3   -2.1];
deltavec=[-0.82 -0.98];
table4 = NaN(size(cvec,2),3);
% lambda=0.02;
% lambda=0.03;
% lambda=0.04;
% lambda=0.05;
% lambda=0.06;
lambda=0.07;

mu_noise = [0 0];
alpha = 0; mu = 0;

tstatVK03 = NaN(rep,size(Tvec,2));

betahat = 0; %case 1 - Valkanov (2003)
% betahat = 1; %case 3 - Valkanov (2003)

for tt=1:size(Tvec,2)
    T=Tvec(tt);
    k= floor(lambda * T);
    for cc = 1:size(deltavec,2)
        delta= deltavec(cc); 
        c = cvec(cc);
        phi = 1 + c/T;
        for ii=1:rep
            %                 ii
            starty=0;
            %Routine
            y=starty*ones(T+1,1); x=starty*ones(T+1,1);
            
            % Generate values from a bivariate normal distribution with specified mean
            % vector and covariance matrix.
            Sigma = [1 delta; delta 1]; R = chol(Sigma);
            e = repmat(mu_noise,T+1,1) + randn(T+1,2)*R;
            
            for i=1:T
                x(i+1,1) =  mu    + phi   * x(i,1)+e(i+1,2);
                y(i+1,1) =  alpha + betahat*x(i,1)+e(i+1,1);
            end
            
            x = trimr(x,1,0); % Tx1
            y = trimr(y,1,0); % Tx1
            
            Z = zeros(T,1); temp=y;
            for i=1:k
                temp = [y(1+i:end);  zeros(i,1)];
                Z = Z + temp;
            end
            Z = trimr(Z,0,k);
            x1 = trimr(x,0,k); 
            smpl_range = size(x1,1); X = [ones(smpl_range,1) x1];
            
            results = ols(Z,X);
            tstatVK03(ii,tt) = results.tstat(2);
        end
        % a useful summary of tails
        table4(cc,:) = quantile(tstatVK03(:,tt)/sqrt(Tvec(tt)),[.90 .95 .99]);
    end
    table4
    clear table4; table4 = NaN(size(cvec,2),8);
end