clc; clear;
%--------------------------------------------------------------------------
%%Wild Bootstrap for heteroscedastic residuals
%--------------------------------------------------------------------------
% written by:
% Andrea Tamoni && Arie E. Gozluklu
% Bocconi University, Via Roentgen 1,20136 Italy 
% www.arieskenazi.com/research
% September,01,2009
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%&&&&&&&&&
clc; clear; close all

Transform_Data

hypo = 0;

nobs = size(data(:,1),1);

%This is the sample used to compute regressand and regressor
smplsdate = ical(1904,1,cstr);
smpledate = ical(2008,1,cstr);

% smplsdate = ical(1909,1,cstr);
% smplsdate = ical(1955,1,cstr);

% % for Boudoukh et al. regressor
% smplsdate = ical(1926,1,cstr); 
% smpledate = ical(2003,1,cstr);

%smpledate = end_date;
% smpledate = ical(1954,1,cstr);
% smpledate = ical(2008,1,cstr);

%%
Hvec=[1:6]; myp = NaN(1,length(Hvec)); prct_stat = NaN(1,length(Hvec));
for hh=1:length(Hvec)
    H=Hvec(hh);
%     exret = compounded_return(lret_ex(smplsdate:smpledate,1),H);
%     exret = compounded_return(ret_r(smplsdate:smpledate,1),H);
%     exret = compounded_return(div_gr_r(smplsdate:smpledate,1),H);
    exret = compounded_return(ret_r(smplsdate:smpledate,1)-div_gr_r(smplsdate:smpledate,1),H);
    
    % x1 = trimr(ldp(smplsdate:smpledate,1),0,H);
    % x1 = trimr(ldp5494(smplsdate:smpledate,1),0,H);
    % x1 = trimr(ldpc(smplsdate:smpledate,1),0,H);
    
%     c2 = [-1.1303 -1.1536 -1.1507  -1.1517 -1.1480 -1.1356];
%     c3 = [-1.6583 -1.5616 -1.6127 -1.5808 -1.5666 -1.6504];
%     CointldptfpmyVECM = -(lp -c2(hh)ld + c3(hh)* my);
    
%     c3 = [-0.42 -0.44 -0.38 -0.36 -0.33 -0.29]./[0.19 0.20 0.16 0.16 0.14 0.13]; % for real returns
%     c3 = [-0.12 -0.03 0.03 0.06 0.06 0.06]./[0.10 0.05 0.02 0.01 -0.005 -0.005]; % for dividends growth
    c3 = [-0.55 -0.47 -0.35 -0.31 -0.27 -0.23]./[0.28 0.24 0.18 0.16 0.14 0.12]; % for returns - dividends growth
    CointldptfpmyVECM = -(lp -ld + c3(hh)* my);
    x1 = trimr(CointldptfpmyVECM(smplsdate:smpledate,1),0,H);


%add the constant
smpl_range = size(x1,1);
xreg = [ones(smpl_range,1) x1];
%%
nlag=2*(H-1);
results= nwest(exret,xreg,nlag);
bstd=results.beta(2)/results.tstat(2);
maint = results.tstat(2);

% results= ols(exret,xreg);
% mainbeta = results.beta(2); bstd = results.bstd(2);
% maint = (mainbeta-hypo)/bstd;

epshat= results.resid;
yhat= results.yhat;

%% also generate "impose the null hypothesis" yhat and residual
temp_y= exret-xreg(:,2)*hypo; 
% resultstemp= nwest(temp_y,xreg(:,1),nlag);
resultstemp= ols(temp_y,xreg(:,1));
epshat_imposed= resultstemp.resid;
yhat_imposed  = resultstemp.yhat;

% yhat_imposed=yhat_imposed+xreg(:,2)*hypo; 
bootsteps=4999;
boott=zeros(1,bootsteps);

for bb=1:bootsteps
    temp=randraw('rademacher', [], results.nobs );
    
    %% to impose null hypothesis uncomment the following two lines
    %wildresid = epshat*(2*pos-1);
    %wildy     = yhat+wildresid;
    
    %%
    wildResid = epshat_imposed.*temp;
    wildY     = yhat_imposed+wildResid;
    
    %  resultsboot= nwest(wildy,xreg,nlag);
    %  bstdboot=resultsboot.beta(2)/resultsboot.tstat(2);
    resultsboot= ols(wildY,xreg);
    bstdboot=resultsboot.bstd(2);
    boot_wild=(resultsboot.beta(2)-hypo)/bstdboot;
    %  boot_wild=(resultsboot.beta-mainbeta)/resultsboot.bstd;
    boott(bb)=boot_wild;
end

% nboot=sum(abs(boott - maint) < 0.000001);
nboot=sum(abs(boott) > abs(maint));
myp(hh)=nboot/bootsteps; 
prct_stat(hh)= 2*min(myp(hh),(1-myp(hh)));
end